Option Strict Off
Option Explicit On 

Imports System.Runtime.InteropServices

Module m4iz

    '///
    '//// mgc4iz.dll  Header Ver4.1600a
    '//
    '///  (C) m.magic & K Maruyama. All rights reserved.

    '//
    '//// common
    '//
    Public Const MIZ_SUCCESS As Integer = 0
    Public Const MIZ_TRUE As Integer = 1
    Public Const MIZ_FALSE As Integer = 0
    Public Const MIZ_YES As Integer = MIZ_TRUE
    Public Const MIZ_NO As Integer = MIZ_FALSE
    Public Const MIZ_NULL As Integer = 0
    Public Const MIZ_MAX_PATH As Integer = 259
    Public Const MIZ_LENGTH_NAME As Integer = 511
    Public Const MIZ_LENGTH_VALUE As Integer = 65535
    Public Const MIZ_LENGTH_RAWVALUE As Integer = 65535

    '// ߂l
    Public Const MIZ_LAST_FIELD As Integer = 100
    '// Error
    Public Const MIZ_FAILURE As Integer = -1
    Public Const MIZ_ERR_FILE As Integer = -101
    Public Const MIZ_ERR_UNKNOWN_FILE As Integer = -102
    Public Const MIZ_ERR_NON_EXIF As Integer = -103
    Public Const MIZ_ERR_MEMORY As Integer = -104
    Public Const MIZ_ERR_NO_RESOURCE As Integer = -106
    Public Const MIZ_ERR_RESOURCE As Integer = -107
    Public Const MIZ_ERR_THUMBNAIL_IMAGE As Integer = -108
    Public Const MIZ_ERR_THAMBNAIL_MEMORY As Integer = -300
    Public Const MIZ_ERR_FILE_COPY As Integer = -400        '// 摜t@C̃Rs[sS
    Public Const MIZ_ERR_FILE_WRITE As Integer = -401       '// HTMLt@C̃Rs[sS
    public Const MIZ_ERR_FORM_POINTER  As Integer = -402    '// form ̏s
    Public Const MIZ_ERR_FORM_SIZE  As Integer = -403       '// form ̃TCYs
    Public Const MIZ_ERR_FORM_NOT_READY  As Integer = -404  '// form resourse ̎w肪Ȃ
    Public Const MIZ_ERR_FORM_QUEUE As Integer = -405       '// ҂s̃TCYs
    Public Const MIZ_ERR_FORM_VALIABLES  As Integer = -406  '// form ̕ϐ̐s

    Structure STRING128
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=128)> _
        Public s As String
    End Structure

    Structure STRING256
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=256)> _
        Public s As String
    End Structure

    Structure STRING512
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=512)> _
        Public s As String
    End Structure

    '//
    '//// mizInitialize
    '//

    '// \
    Structure MIZ_INI_DATA
        <MarshalAs(UnmanagedType.LPWStr)> _
        Dim resourceFile As String
    End Structure

    '//
    '////	Begin
    '//
    Public Const MIZ_COMMAND As Integer = &HFF
    Public Const MIZ_OPTIONS As Integer = &HFFFFFF00
    Public Const MIZ_CMD_RESET As Integer = &H0
    Public Const MIZ_CMD_READ As Integer = &H1
    Public Const MIZ_CMD_BEGIN As Integer = &H2
    Public Const MIZ_CMD_GET_FIELD As Integer = &H3
    Public Const MIZ_CMD_GET_THUMBNAIL As Integer = &H4
    Public Const MIZ_CMD_GET_FILE_CRC As Integer = &H5
    Public Const MIZ_CMD_LOAD_FORM As Integer = &H6
    Public Const MIZ_CMD_SAVE_FILE As Integer = &H7

    Public Const MIZ_OPT_NO_RESET As Integer = &H0              '// Option for RESET
    Public Const MIZ_OPT_RESET_THUMBNAIL As Integer = &H100     '// Option for RESET
    Public Const MIZ_OPT_RESET_FIELD As Integer = &H200         '// Option for RESET
    Public Const MIZ_OPT_UNIT As Integer = &H0                  '// Option for READ
    Public Const MIZ_OPT_INCLUDE_THUMBNAIL As Integer = &H100   '// Option for READ
    Public Const MIZ_OPT_NON_UNIT As Integer = &H200            '// Option for READ
    Public Const MIZ_OPT_RISE As Integer = &H0                  '// Option for BEGIN
    Public Const MIZ_OPT_DOWN As Integer = &H100                '// Option for BEGIN
    Public Const MIZ_OPT_GET_STRINGS As Integer = &H0           '// Option for GET_FIELD 
    Public Const MIZ_OPT_GET_DATA As Integer = &H100            '// Option for GET_FIELD 
    Public Const MIZ_OPT_CSV As Integer = &H0                   '// Option for CMD_SAVE_FILE
    Public Const MIZ_OPT_HTML_FORM0 As Integer = &H100          '// Option for CMD_SAVE_FILE
    Public Const MIZ_OPT_HTML_FORM1 As Integer = &H200          '// Option for CMD_SAVE_FILE
    Public Const MIZ_OPT_FILE_TYPE As Integer = &HFF00          '// Option for CMD_SAVE_FILE
    Public Const MIZ_OPT_CODE As Integer = &HFFF0000            '// Option for cmdSAVE_FILE
    Public Const MIZ_OPT_CODE_SJIS As Integer = &H0             '// Option for cmdSAVE_FILE
    Public Const MIZ_OPT_CODE_UTF8 As Integer = &H10000         '// Option for cmdSAVE_FILE
    Public Const MIZ_OPT_CODE_UTF16BE As Integer = &H20000      '// Option for cmdSAVE_FILE
    Public Const MIZ_OPT_CODE_UTF16LE As Integer = &H30000      '// Option for cmdSAVE_FILE
        

    Public Const MIZ_RESET_ALL As Integer = MIZ_CMD_RESET Or MIZ_OPT_RESET_FIELD Or MIZ_OPT_RESET_THUMBNAIL
    Public Const MIZ_RESET_FIELD As Integer = MIZ_CMD_RESET Or MIZ_OPT_RESET_FIELD
    Public Const MIZ_RESET_THUMBNAIL As Integer = MIZ_CMD_RESET Or MIZ_OPT_RESET_THUMBNAIL
    Public Const MIZ_READ As Integer = MIZ_CMD_READ Or MIZ_OPT_NON_UNIT
    Public Const MIZ_READ_PLUS_ONE As Integer = MIZ_CMD_READ Or MIZ_OPT_INCLUDE_THUMBNAIL Or MIZ_OPT_NON_UNIT
    Public Const MIZ_BEGIN_RISE As Integer = MIZ_CMD_BEGIN Or MIZ_OPT_RISE
    Public Const MIZ_BEGIN_DOWN As Integer = MIZ_CMD_BEGIN Or MIZ_OPT_DOWN
    Public Const MIZ_GET_STRINGS As Integer = MIZ_CMD_GET_FIELD
    Public Const MIZ_GET_DATA As Integer = MIZ_CMD_GET_FIELD Or MIZ_OPT_GET_DATA
    Public Const MIZ_GET_THUMBNAIL As Integer = MIZ_CMD_GET_THUMBNAIL
    Public Const MIZ_GET_FILE_CRC As Integer = MIZ_CMD_GET_FILE_CRC


    '//// IFD ̎
    Public Const MIZ_KINDIFD_TIFF As Integer = &H0
    Public Const MIZ_KINDIFD_EXIF As Integer = &H8769
    Public Const MIZ_KINDIFD_GPS As Integer = &H8825
    Public Const MIZ_KINDIFD_INTEROPERABILITYIFD As Integer = &HA005
    Public Const MIZ_KINDIFD_THUMBNAIL As Integer = &H1
    '//// IFD f[^`
    Public Const MIZ_TIF_LITTLE_ENDIAN As Short = &H4949 '// GfBA`
    Public Const MIZ_TIF_BIG_ENDIAN As Short = &H4D4D '// rbOGfBA`
    '//// IFD TYPE
    Public Const MIZ_IFD_TYPE_BYTE As Short = 1  '// 8 rbgB
    Public Const MIZ_IFD_TYPE_ASCII As Short = 2  '// 7 sbgASCII R[h[߂8 rbgoCgB
    Public Const MIZ_IFD_TYPE_SHORT As Short = 3  '// 16 rbgi2 oCgjB
    Public Const MIZ_IFD_TYPE_LONG As Short = 4  '// 32 rbgi4 oCgjB
    Public Const MIZ_IFD_TYPE_RATIONAL As Short = 5  '// _u LONGBŏLONG ͕qA2 ڂLONG ͕\B
    Public Const MIZ_IFD_TYPE_UNDEFINED As Short = 7  '// tB[h̒`ɂAǂȒlƂĂǂ8 rbgoCgB
    Public Const MIZ_IFD_TYPE_SLONG As Short = 9  '// 32 rbgi4 oCgjti2 ̕␔\jB
    Public Const MIZ_IFD_TYPE_SRATIONAL As Short = 10 '// _u SLONGBŏSLONG ͕qA2 ڂSLONG ͕\B

    '// html resource ID
    Public Const MIZ_IDR_HTML_FORM0 As Integer = 64000 '// IDR_HTML_FORM0 for openoffice
    Public Const MIZ_IDR_HTML_FORM1 As Integer = 64001 '// IDR_HTML_FORM1 for microsoft office
    '// html form
    Public Const MIZ_FORM_FIELD As Integer = 0
    Public Const MIZ_FORM_HEADER As Integer = 1
    Public Const MIZ_FORM_IMAGE As Integer = 2
    Public Const MIZ_FORM_FIELDS_HEADER As Integer = 3
    Public Const MIZ_FORM_OTHER As Integer = 4
    Public Const MIZ_FORM_FREEONE As Integer = 5
    Public Const MIZ_FORM_FOOTER As Integer = 6
    Public Const MIZ_FORM_METADATA0S As Integer = 7
    Public Const MIZ_FORM_METADATA1S As Integer = 8 '// ms form
    Public Const MIZ_FORM_METADATA2S As Integer = 9 '// ms form
    Public Const MIZ_FORM_STRUCTURE0 As Integer = 10
    Public Const MIZ_FORM_STRUCTURE1 As Integer = MIZ_FORM_STRUCTURE0
    Public Const MIZ_FORM_MAX As Integer = 11
    Public Const MIZ_FORM_COUNT0 As Integer = 9
    Public Const MIZ_FORM_COUNT1 As Integer = MIZ_FORM_MAX
    '// size of html form ////////////////////////////////////////////////////////////////////////////// 
    '// If FORM of a resource is changed, it is necessary to change the form size. 
    '// Please change a required line. 	-->
    Public Const MIZ_FORM_LENGTH_DONT_USE As Integer = 0
    Public Const MIZ_FORM_LENGTH_FIELD As Integer = 285
    Public Const MIZ_FORM_LENGTH_HEADER As Integer = 226
    Public Const MIZ_FORM_LENGTH_FIELDS_HEADER As Integer = 347
    Public Const MIZ_FORM_LENGTH_IMAGE As Integer = 204
    Public Const MIZ_FORM_LENGTH_OTHER As Integer = 71
    Public Const MIZ_FORM_LENGTH_FREEONE As Integer = 3
    Public Const MIZ_FORM_LENGTH_FOOTER As Integer = 91
    Public Const MIZ_FORM_LENGTH_METADATA0S As Integer = 33
    Public Const MIZ_FORM_LENGTH_METADATA1S As Integer = 19
    Public Const MIZ_FORM_LENGTH_METADATA2S As Integer = 30
    Public Const MIZ_FORM_LENGTH_STRUCTURE0 As Integer = 505
    Public Const MIZ_FORM_LENGTH_STRUCTURE1 As Integer = 874
    Public Const MIZ_FORM0_LENGTH As Integer = 1765
    Public Const MIZ_FORM1_LENGTH As Integer = 2183

    Public Const MIZ_FORM_ENU_LENGTH_STRUCTURE0 As Integer = 494
    Public Const MIZ_FORM_ENU_LENGTH_STRUCTURE1 As Integer = 862
    Public Const MIZ_FORM0_ENU_LENGTH As Integer = 1754
    Public Const MIZ_FORM1_ENU_LENGTH As Integer = 2171
    '// <-- 
        
        
    '// Elements for Form
    Public Const MIZ_ELEMENT_DONT_OUTPUT As Integer = 0
    Public Const MIZ_ELEMENT_HEADER As Integer = 1
    Public Const MIZ_ELEMENT_IMAGE As Integer = 2
    Public Const MIZ_ELEMENT_FIELD_HEADER As Integer = 3
    Public Const MIZ_ELEMENT_FIELDS As Integer = 4
    Public Const MIZ_ELEMENT_OTHER0 As Integer = 5
    Public Const MIZ_ELEMENT_OTHER1 As Integer = 6
    Public Const MIZ_ELEMENT_OTHER2 As Integer = 7
    Public Const MIZ_ELEMENT_OTHER3 As Integer = 8
    Public Const MIZ_ELEMENT_OTHER4 As Integer = 9
    Public Const MIZ_ELEMENT_OTHER5 As Integer = 10
    Public Const MIZ_ELEMENT_OTHER6 As Integer = 11
    Public Const MIZ_ELEMENT_OTHER7 As Integer = 12
    Public Const MIZ_ELEMENT_OTHER8 As Integer = 13
    Public Const MIZ_ELEMENT_OTHER9 As Integer = 14
    Public Const MIZ_ELEMENT_FREEONE0 As Integer = 15
    Public Const MIZ_ELEMENT_FREEONE1 As Integer = 16
    Public Const MIZ_ELEMENT_FREEONE2 As Integer = 17
    Public Const MIZ_ELEMENT_FREEONE3 As Integer = 18
    Public Const MIZ_ELEMENT_FREEONE4 As Integer = 19
    Public Const MIZ_ELEMENT_FREEONE5 As Integer = 20
    Public Const MIZ_ELEMENT_FREEONE6 As Integer = 21
    Public Const MIZ_ELEMENT_FREEONE7 As Integer = 22
    Public Const MIZ_ELEMENT_FREEONE8 As Integer = 23
    Public Const MIZ_ELEMENT_FREEONE9 As Integer = 24
    Public Const MIZ_ELEMENT_FOOTER As Integer = 25
    Public Const MIZ_ELEMENTS_MAX As Integer = 24
    Public Const MIZ_ELEMENTS_OTHER_MAX As Integer = 9
    Public Const MIZ_ELEMENTS_FREEONE_MAX As Integer = 9
    '// structure
    Public Const MIZ_STRUCTURE_SIZE_A As Integer = 511
    '// structure
    Public Const MIZ_HEADER_SIZE_A As Integer = 255
    Public Const MIZ_HEADER_SIZE_B As Integer = 127
    '// kind of metadata
    Public Const MIZ_METADATA_MAX As Integer = 23
    Public Const MIZ_METADATA_SIZE_A As Integer = 511
    Public Const MIZ_METADATA_SIZE_B As Integer = 127
    '// field
    Public Const MIZ_FIELD_SIZE_A As Integer = 127
    '// other
    Public Const MIZ_OTHER_SIZE_A As Integer = 511
    '// free one
    Public Const MIZ_FREEONE_SIZE_A As Integer = 511
    '// footer
    Public Const MIZ_FOOTER_SIZE_A As Integer = 255
    '// csv
    Public Const MIZ_CSV_SIZE_A As Integer = 511
    Public Const MIZ_CSV_SIZE_B As Integer = 127
    Public Const MIZ_CSV_MAX_COUNT As Integer = 15



    '// \
    Structure MIZ_FIELD_DATA
        Dim endian As Short
        Dim tag As Short
        Dim type As Short
        Dim count As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_LENGTH_RAWVALUE + 1)> _
        Dim values() As Byte
        Public Sub initialize()
            ReDim values(MIZ_LENGTH_RAWVALUE)
        End Sub
    End Structure

    Structure MIZ_FIELD_STRINGS
        Dim kindIFD As Integer
        Dim tag As Short
        Dim name As String
        Dim values As String
    End Structure

    Structure MIZ_TEXT_SIZE
        Dim name As Integer
        Dim value As Integer
        Dim rawValues As Integer
    End Structure

    Structure MIZ_THUMBNAIL_IMAGE
        Dim compression As Integer
        Dim size As Integer
        Dim image As IntPtr
    End Structure

    '// Html resource
    Structure MIZ_HTML_RESOURCE
        Dim id As Integer
        Dim totalLength As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_FORM_MAX + 1)> _
        Dim length() As Integer
        Public Sub initialize()
            ReDim length(MIZ_FORM_MAX)
        End Sub
    End Structure
    '// method for html
    Structure MIZ_METHOD_FOR_FORM0
        '// TARGET
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_MAX_PATH + 1)> _
        Dim pathName As String '// Html o͐ = %drive%\x1
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_MAX_PATH + 1)> _
        Dim fileName As String      '// K .htm t
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_ELEMENTS_MAX + 1)> _
        Dim queue() As Integer      '// elements ̏o͏
        Dim queueCount As Integer   '// Queue ̐

        '// STRUCTURE
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_STRUCTURE_SIZE_A + 1)> _
        Dim title As String
        '// METADATAS
        Dim countForMetadata0s As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_METADATA_MAX + 1)> _
        Dim nameOfMetadata0() As STRING128
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_METADATA_MAX + 1)> _
        Dim contentOfMetadata0() As STRING512

        '// ȉ elements -->
        '// HEADER
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_HEADER_SIZE_A + 1)> _
        Dim headerTitle As String
        <VBFixedString(MIZ_HEADER_SIZE_B), MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_HEADER_SIZE_B + 1)> _
        Dim date_ As String

        '// IMAGE
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_MAX_PATH + 1)> _
        Dim imagePathAndName As String  '// 摜̏ꏊƃt@C = %drive%\folder\image.jpg
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_MAX_PATH + 1)> _
        Dim imageName As String         '// 摜t@C = image.jpg
        Dim imageWidth As Integer
        Dim imageHeight As Integer
        '// FIELDS HEADER
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
        Dim fieldName() As STRING128
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=5)> _
        Dim kind() As STRING128
        '// OTHER
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_ELEMENTS_OTHER_MAX + 1)> _
        Dim other() As STRING512
        '// FREEONE
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_ELEMENTS_FREEONE_MAX + 1)> _
        Dim freeOne() As STRING512
        '// FOOTER
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_FOOTER_SIZE_A + 1)> _
        Dim footer As String
        '// <-- elements

        Public Sub initialize()
            ReDim queue(MIZ_ELEMENTS_MAX)
            ReDim nameOfMetadata0(MIZ_METADATA_MAX)
            ReDim contentOfMetadata0(MIZ_METADATA_MAX)
            ReDim fieldName(3)
            ReDim kind(4)
            ReDim other(MIZ_ELEMENTS_OTHER_MAX)
            ReDim freeOne(MIZ_ELEMENTS_FREEONE_MAX)
        End Sub
    End Structure

    Structure MIZ_METHOD_FOR_FORM1
        '// TARGET
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_MAX_PATH + 1)> _
        Dim pathName As String '// Html o͐ = %drive%\x1
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_MAX_PATH + 1)> _
        Dim fileName As String                                           '// K .htm t
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_ELEMENTS_MAX + 1)> _
        Dim queue() As Integer       '// elements ̏o͏
        Dim queueCount As Integer    '// Queue ̐

        '// STRUCTURE
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_STRUCTURE_SIZE_A + 1)> _
        Dim title As String
        '// METADATAS
        Dim countForMetadata0s As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_METADATA_MAX + 1)> _
        Dim nameOfMetadata0() As STRING128
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_METADATA_MAX + 1)> _
        Dim contentOfMetadata0() As STRING512

        '// ȉ elements -->
        '// HEADER
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_HEADER_SIZE_A + 1)> _
        Dim headerTitle As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_HEADER_SIZE_B + 1)> _
        Dim date_ As String

        '// IMAGE
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_MAX_PATH + 1)> _
        Dim imagePathAndName As String  '// 摜̏ꏊƃt@C = %drive%\folder\image.jpg
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_MAX_PATH + 1)> _
        Dim imageName As String         '// 摜t@C = image.jpg
        Dim imageWidth As Integer
        Dim imageHeight As Integer
        '// FIELDS HEADER
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=4)> _
        Dim fieldName() As STRING128
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=5)> _
        Dim kind() As STRING128
        '// OTHER
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_ELEMENTS_OTHER_MAX + 1)> _
        Dim other() As STRING512
        '// FREEONE
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_ELEMENTS_FREEONE_MAX + 1)> _
        Dim freeOne() As STRING512
        '// FOOTER
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_FOOTER_SIZE_A + 1)> _
        Dim footer As String
        '// <-- elements

        '// METADATAS1
        Dim countForMetadata1s As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_METADATA_MAX + 1)> _
        Dim nameOfMetadata1() As STRING128
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_METADATA_MAX + 1)> _
        Dim contentOfMetadata1() As STRING512
        '// METADATAS2
        Dim countForMetadata2s As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_METADATA_MAX + 1)> _
        Dim nameOfMetadata2() As STRING128
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_METADATA_MAX + 1)> _
        Dim typeOfMetadata2() As STRING128
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_METADATA_MAX + 1)> _
        Dim contentOfMetadata2() As STRING512

        Public Sub initialize()
            ReDim queue(MIZ_ELEMENTS_MAX)
            ReDim nameOfMetadata0(MIZ_METADATA_MAX)
            ReDim contentOfMetadata0(MIZ_METADATA_MAX)
            ReDim fieldName(3)
            ReDim kind(4)
            ReDim other(MIZ_ELEMENTS_OTHER_MAX)
            ReDim freeOne(MIZ_ELEMENTS_FREEONE_MAX)

            ReDim nameOfMetadata1(MIZ_METADATA_MAX)
            ReDim contentOfMetadata1(MIZ_METADATA_MAX)
            ReDim nameOfMetadata2(MIZ_METADATA_MAX)
            ReDim typeOfMetadata2(MIZ_METADATA_MAX)
            ReDim contentOfMetadata2(MIZ_METADATA_MAX)
        End Sub
    End Structure

    '// csv
    Structure MIZ_METHOD_FOR_CSV
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_MAX_PATH + 1)> _
        Dim pathName As String  '// csv o͐ = %drive%\x1
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=MIZ_MAX_PATH + 1)> _
        Dim fileName As String  '// K .csv t

        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=5)> _
        Dim kind() As STRING128
        Dim count As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_CSV_MAX_COUNT + 1)> _
        Dim name() As STRING512
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=MIZ_CSV_MAX_COUNT + 1)> _
        Dim value() As STRING512

        Public Sub initialize()
            ReDim kind(4)
            ReDim name(MIZ_CSV_MAX_COUNT)
            ReDim value(MIZ_CSV_MAX_COUNT)
        End Sub
    End Structure



    '//
    '//// TIFF IFD TAG +Ver1.5
    '//
    Public Const MIZ_TAG_IMAGEWIDTH As Short = &H100                '// 摜̕ 
    Public Const MIZ_TAG_IMAGELENGTH As Short = &H101               '// 摜̍ 
    Public Const MIZ_TAG_BITSPERSAMPLE As Short = &H102             '// 摜̃rbg̐[
    Public Const MIZ_TAG_COMPRESSION As Short = &H103               '// k̎
    Public Const MIZ_TAG_PHOTOMETRICINTERPRETATION As Short = &H106 '// f\
    Public Const MIZ_TAG_THRESHHOLDING As Short = &H107             '// 臒l
    Public Const MIZ_TAG_CELLWIDTH As Short = &H108                 '// Z
    Public Const MIZ_TAG_CELLLENGTH As Short = &H109                '// Z
    Public Const MIZ_TAG_FILLORDER As Short = &H10A                 '// tBI[_[
    Public Const MIZ_TAG_DOCUMENTNAME As Short = &H10D              '// ͉摜
    Public Const MIZ_TAG_IMAGEDESCRIPTION As Short = &H10E          '// 摜^Cg
    Public Const MIZ_TAG_MAKE As Short = &H10F                      '// 摜͋@̃[J[
    Public Const MIZ_TAG_MODEL As Short = &H110                     '// 摜͋@̃f
    Public Const MIZ_TAG_STRIPOFFSETS As Short = &H111              '// 摜f[^̃P[V 
    Public Const MIZ_TAG_ORIENTATION As Short = &H112               '// 摜
    Public Const MIZ_TAG_SAMPLESPERPIXEL As Short = &H115           '// R|[lg
    Public Const MIZ_TAG_ROWSPERSTRIP As Short = &H116              '// XgbṽC
    Public Const MIZ_TAG_STRIPBYTECOUNTS As Short = &H117           '// Xgbṽf[^
    Public Const MIZ_TAG_MINSAMPLEVALUE As Short = &H118            '// ŏTvOl
    Public Const MIZ_TAG_MAXSAMPLEVALUE As Short = &H119            '// őTvOl
    Public Const MIZ_TAG_XRESOLUTION As Short = &H11A               '// 摜̉̕𑜓x
    Public Const MIZ_TAG_YRESOLUTION As Short = &H11B               '// 摜̍̉𑜓x
    Public Const MIZ_TAG_PLANARCONFIGURATION As Short = &H11C       '// 摜f[^̕
    Public Const MIZ_TAG_PAGENAME As Short = &H11D                  '// ͉摜y[W
    Public Const MIZ_TAG_XPOSITION As Short = &H11E                 '// 摜̂wʒu
    Public Const MIZ_TAG_YPOSITION As Short = &H11F                 '// 摜̂xʒu
    Public Const MIZ_TAG_FREEOFFSETS As Short = &H120               '// f[^ʒu
    Public Const MIZ_TAG_FREEBYTECOUNTS As Short = &H121            '// f[^
    Public Const MIZ_TAG_GRAYRESPONSEUNIT As Short = &H122          '// OCX|XP
    Public Const MIZ_TAG_GRAYRESPONSECURVE As Short = &H123         '// OCX|X
    Public Const MIZ_TAG_T4OPTIONS As Short = &H124                 '// T4 IvV
    Public Const MIZ_TAG_T6OPTIONS As Short = &H125                 '// T6 IvV
    Public Const MIZ_TAG_RESOLUTIONUNIT As Short = &H128            '// 摜̕ƍ̉𑜓x̒P
    Public Const MIZ_TAG_PAGENUMBER As Short = &H129                '// ͉摜y[W
    Public Const MIZ_TAG_TRANSFERFUNCTION As Short = &H12D          '// ĐKJ[u 
    Public Const MIZ_TAG_SOFTWARE As Short = &H131                  '// gp\tgEFA
    Public Const MIZ_TAG_DATETIME As Short = &H132                  '// t@CύX 
    Public Const MIZ_TAG_ARTIST As Short = &H13B                    '// Җ 
    Public Const MIZ_TAG_HOSTCOMPUTER As Short = &H13C              '// zXgRs[^[
    Public Const MIZ_TAG_PREDICTOR As Short = &H13D                 '// Predictor
    Public Const MIZ_TAG_WHITEPOINT As Short = &H13E                '// QƔF_̐FxWl
    Public Const MIZ_TAG_PRIMARYCHROMATICITIES As Short = &H13F     '// F̐FxWl
    Public Const MIZ_TAG_COLORMAP As Short = &H140                  '// J[pbg
    Public Const MIZ_TAG_HALFTONEHINTS As Short = &H141             '// n[tg[
    Public Const MIZ_TAG_TILEWIDTH As Short = &H142                 '// ^C
    Public Const MIZ_TAG_TILELENGTH As Short = &H143                '// ^C
    Public Const MIZ_TAG_TILEOFFSETS As Short = &H144               '// ^CItZbgʒu
    Public Const MIZ_TAG_TILEBYTECOUNTS As Short = &H145            '// ^CoCg
    Public Const MIZ_TAG_INKSET As Short = &H14C                    '// CNZbg
    Public Const MIZ_TAG_INKNAMES As Short = &H14D                  '// CN
    Public Const MIZ_TAG_NUMBEROFINKS As Short = &H14E              '// CN
    Public Const MIZ_TAG_DOTRANGE As Short = &H150                  '// hbgW
    Public Const MIZ_TAG_TARGETPRINTER As Short = &H151             '// v^
    Public Const MIZ_TAG_EXTRASAMPLES As Short = &H152              '// ǉf\
    Public Const MIZ_TAG_SAMPLEFORMAT As Short = &H153              '// W{
    Public Const MIZ_TAG_SMINSAMPLEVALUE As Short = &H154           '// ŏ̕W{l
    Public Const MIZ_TAG_SMAXSAMPLEVALUE As Short = &H155           '// ő̕W{l
    Public Const MIZ_TAG_TRANSFERRANGE As Short = &H156             '// TransferRange
    Public Const MIZ_TAG_JPEGPROC As Short = &H200                  '// JPEGProc
    Public Const MIZ_TAG_JPEGINTERCHANGEFORMAT As Short = &H201     '// JPEG SOI ւ̃ItZbg
    Public Const MIZ_TAG_JPEGINTERCHANGEFORMATLENGTH As Short = &H202   '// JPEG f[^̃oCg
    Public Const MIZ_TAG_JPEGRESTARTINTERVAL As Short = &H203       '// JPEGRestartInterval
    Public Const MIZ_TAG_JPEGLOSSLESSPREDICTORS As Short = &H205    '// JPEGLosslessPredictors 
    Public Const MIZ_TAG_JPEGPOINTTRANSFORMS As Short = &H206       '// JPEGPointTransforms 
    Public Const MIZ_TAG_JPEGQTABLES As Short = &H207               '// JPEGQTables 
    Public Const MIZ_TAG_JPEGDCTABLES As Short = &H208              '// JPEGDCTables
    Public Const MIZ_TAG_JPEGACTABLES As Short = &H209              '// JPEGACTables
    Public Const MIZ_TAG_YCBCRCOEFFICIENTS As Short = &H211         '// Fϊ}gNXW
    Public Const MIZ_TAG_YCBCRSUBSAMPLING As Short = &H212          '// YCC ̉f\iC ̊Ԉj
    Public Const MIZ_TAG_YCBCRPOSITIONING As Short = &H213          '// YCC ̉f\iY C ̈ʒuj
    Public Const MIZ_TAG_REFERENCEBLACKWHITE As Short = &H214       '// QƍF_lƎQƔF_l
    Public Const MIZ_TAG_COPYRIGHT As Short = &H8298S               '// Be쌠/ҏW쌠 
    Public Const MIZ_TAG_EXIFIFD_POINTER As Short = &H8769S         '// Exif 
    Public Const MIZ_TAG_GPSINFO_POINTER As Short = &H8825S         '// GPS 
    Public Const MIZ_TAG_NEWSUBFILETYPE As Short = &HFE             '// VTut@C^
    Public Const MIZ_TAG_SUBFILETYPE As Short = &HFF                '// Tut@C^

    '//
    '//// Exif IFD TAG
    '//
    Public Const MIZ_TAG_EXPOSURETIME As Short = &H829AS              '// Io
    Public Const MIZ_TAG_FNUMBER As Short = &H829DS                   '// F io[ 
    Public Const MIZ_TAG_EXPOSUREPROGRAM As Short = &H8822S           '// IovO 
    Public Const MIZ_TAG_SPECTRALSENSITIVITY As Short = &H8824S       '// XyNgx 
    Public Const MIZ_TAG_ISOSPEEDRATINGS As Short = &H8827S           '// ISO Xs[h[g 
    Public Const MIZ_TAG_OECF As Short = &H8828S                      '// dϊ֐ 

    Public Const MIZ_TAG_SENSITIVITYTYPE As Short = &H8830S             '// x						+EXIF 2.3
    Public Const MIZ_TAG_STANDERDOUTPUTSENSITIVITY As Short = &H8831S   '// Wo͊x					+EXIF 2.3
    Public Const MIZ_TAG_RECOMMENDEDEXPOSUREINDEX As Short = &H8832S    '// Iw					+EXIF 2.3
    Public Const MIZ_TAG_ISOSPEED As Short = &H8833S                    '// ISOXs[h					+EXIF 2.3
    Public Const MIZ_TAG_ISOSPEEDLATITUDEYYY As Short = &H8834S         '// ISOXs[h``[h YYY	+EXIF 2.3
    Public Const MIZ_TAG_ISOSPEEDLATITUDEZZZ As Short = &H8835S         '// ISOXs[h``[h ZZZ	+EXIF 2.3

    Public Const MIZ_TAG_EXIF_VERSION As Short = &H9000S              '// Exif o[W 		
    Public Const MIZ_TAG_DATETIMEORIGINAL As Short = &H9003S          '// 摜f[^̐ 		
    Public Const MIZ_TAG_DATETIMEDIGITIZED As Short = &H9004S         '// fBW^f[^̍쐬 	
    Public Const MIZ_TAG_COMPONENTSCONFIGURATION As Short = &H9101S   '// eR|[lg̈Ӗ 		
    Public Const MIZ_TAG_COMPRESSEDBITSPERPIXEL As Short = &H9102S    '// 摜k[h 			
    Public Const MIZ_TAG_SHUTTERSPEEDVALUE As Short = &H9201S         '// Vb^[Xs[h 
    Public Const MIZ_TAG_APERTUREVALUE As Short = &H9202S             '// il 
    Public Const MIZ_TAG_BRIGHTNESSVALUE As Short = &H9203S           '// Pxl 
    Public Const MIZ_TAG_EXPOSUREBIASVALUE As Short = &H9204S         '// I␳l 
    Public Const MIZ_TAG_MAXAPERTUREVALUE As Short = &H9205S          '// Yŏel 
    Public Const MIZ_TAG_SUBJECTDISTANCE As Short = &H9206S           '// ʑ̋ 
    Public Const MIZ_TAG_METERINGMODE As Short = &H9207S              '//  
    Public Const MIZ_TAG_LIGHTSOURCE As Short = &H9208S               '//  
    Public Const MIZ_TAG_FLASH As Short = &H9209S                     '// tbV 
    Public Const MIZ_TAG_FOCALLENGTH As Short = &H920AS               '// Yœ_
    Public Const MIZ_TAG_SUBJECTAREA As Short = &H9214S               '// ʑ̗̈
    Public Const MIZ_TAG_MAKERNOTE As Short = &H927CS                 '// [J[m[g 				
    Public Const MIZ_TAG_USERCOMMENT As Short = &H9286S               '// [U[Rg 			
    Public Const MIZ_TAG_SUBSECTIME As Short = &H9290S                '// DateTime ̃TuZbN 			
    Public Const MIZ_TAG_SUBSECTIMEORIGINAL As Short = &H9291S        '// DateTimeOriginal ̃TuZbN 		
    Public Const MIZ_TAG_SUBSECTIMEDIGITIZED As Short = &H9292S       '// DateTimeDigitized ̃TuZbN 		
    Public Const MIZ_TAG_FLASHPIXVERSION As Short = &HA000S           '// ΉtbVsbNXo[W 	
    Public Const MIZ_TAG_COLORSPACE As Short = &HA001S                '// Fԏ 				
    Public Const MIZ_TAG_PIXELXDIMENSION As Short = &HA002S           '// 摜 				
    Public Const MIZ_TAG_PIXELYDIMENSION As Short = &HA003S           '// 摜 				
    Public Const MIZ_TAG_RELATEDSOUNDFILE As Short = &HA004S          '// ֘At@C 			
    Public Const MIZ_TAG_INTEROPERABILIY_IFD_POINTER As Short = &HA005S   '// ݊IFD ւ̃|C^
    Public Const MIZ_TAG_FLASHENERGY As Short = &HA20BS               '// tbVx 
    Public Const MIZ_TAG_SPATIALFREQUENCYRESPONSE As Short = &HA20CS  '// Ԏg 
    Public Const MIZ_TAG_FOCALPLANEXRESOLUTION As Short = &HA20ES     '// œ_ʂ̉̕𑜓x 
    Public Const MIZ_TAG_FOCALPLANEYRESOLUTION As Short = &HA20FS     '// œ_ʂ̍̉𑜓x 
    Public Const MIZ_TAG_FOCALPLANERESOLUTIONUNIT As Short = &HA210S  '// œ_ʉ𑜓xP 
    Public Const MIZ_TAG_SUBJECTLOCATION As Short = &HA214S           '// ʑ̈ʒu 
    Public Const MIZ_TAG_EXPOSUREINDEX As Short = &HA215S             '// IoCfbNX 
    Public Const MIZ_TAG_SENSINGMETHOD As Short = &HA217S             '// ZT[ 
    Public Const MIZ_TAG_FILESOURCE As Short = &HA300S                '// t@C\[X
    Public Const MIZ_TAG_SCENETYPE As Short = &HA301S                 '// V[^Cv 
    Public Const MIZ_TAG_CFAPATTERN As Short = &HA302S                '// FA p^[ 
    Public Const MIZ_TAG_CUSTOMRENDERED As Short = &HA401S            '// JX^C[W
    Public Const MIZ_TAG_EXPOSUREMODE As Short = &HA402S              '// Io[h	
    Public Const MIZ_TAG_WHITEBALANCE As Short = &HA403S              '// zCgoX
    Public Const MIZ_TAG_DIGITALZOOMRATIO As Short = &HA404S          '// fBW^Y[
    Public Const MIZ_TAG_FOCALLENGTHIN35MMFILM As Short = &HA405S     '// RTZYœ_
    Public Const MIZ_TAG_SCENECAPTURETYPE As Short = &HA406S          '// V[Be^Cv	
    Public Const MIZ_TAG_GAINCONTROL As Short = &HA407S               '// QCRg[	
    Public Const MIZ_TAG_CONTRAST As Short = &HA408S                  '// RgXg		
    Public Const MIZ_TAG_SATURATION As Short = &HA409S                '// ʓx			
    Public Const MIZ_TAG_SHARPNESS As Short = &HA40AS                 '// V[vlX		
    Public Const MIZ_TAG_DEVICESETTINGDESCRIPTION As Short = &HA40BS  '// @ݒ		
    Public Const MIZ_TAG_SUBJECTDISTANCERANGE As Short = &HA40CS      '// ʑ͈̂̋	
    Public Const MIZ_TAG_IMAGEUNIQUEID As Short = &HA420S             '// Ǝ̉摜 ID		

    Public Const MIZ_TAG_CAMERAOWNERNAME As Short = &HA430S           '// JLҖ		+EXIF 2.3
    Public Const MIZ_TAG_BODYSERIALNUMBER As Short = &HA431S          '// JVAԍ	+EXIF 2.3
    Public Const MIZ_TAG_LENSSPECIFICATION As Short = &HA432S         '// Ydl		+EXIF 2.3
    Public Const MIZ_TAG_LENSMAKE As Short = &HA433S                  '// Y[J[		+EXIF 2.3
    Public Const MIZ_TAG_LENSMODEL As Short = &HA434S                 '// Yf		+EXIF 2.3
    Public Const MIZ_TAG_LENSSERIALNUMBER As Short = &HA435S          '// YVAԍ	+EXIF 2.3


    '//
    '//// GPS IFD TAG
    '//
    Public Const MIZ_TAG_GPS_VERSIONID As Short = &H0            '// GPS ^Õo[W 	
    Public Const MIZ_TAG_GPS_LATITUDEREF As Short = &H1          '// k(N)or (S) 		
    Public Const MIZ_TAG_GPS_LATITUDE As Short = &H2             '// ܓxilj 			
    Public Const MIZ_TAG_GPS_LONGITUDEREF As Short = &H3         '// o(E)or o(W) 		
    Public Const MIZ_TAG_GPS_LONGITUDE As Short = &H4            '// oxilj 			
    Public Const MIZ_TAG_GPS_ALTITUDEREF As Short = &H5          '// x̒P 				
    Public Const MIZ_TAG_GPS_ALTITUDE As Short = &H6             '// xilj 			
    Public Const MIZ_TAG_GPS_TIMESTAMP As Short = &H7            '// GPS ԁiqv̎ԁj
    Public Const MIZ_TAG_GPS_SATELLITES As Short = &H8           '// ʂɎgqM 	
    Public Const MIZ_TAG_GPS_STATUS As Short = &H9               '// GPS M@̏ 		
    Public Const MIZ_TAG_GPS_MEASUREMODE As Short = &HA          '// GPS ̑ʕ@ 			
    Public Const MIZ_TAG_GPS_DOP As Short = &HB                  '// ʂ̐M 			
    Public Const MIZ_TAG_GPS_SPEEDREF As Short = &HC             '// x̒P 				
    Public Const MIZ_TAG_GPS_SPEED As Short = &HD                '// xilj 			
    Public Const MIZ_TAG_GPS_TRACKREF As Short = &HE             '// is̒P 			
    Public Const MIZ_TAG_GPS_TRACK As Short = &HF                '// isilj 		
    Public Const MIZ_TAG_GPS_IMGDIRECTIONREF As Short = &H10     '// Be摜̒̕P 
    Public Const MIZ_TAG_GPS_IMGDIRECTION As Short = &H11        '// Be摜̕ilj
    Public Const MIZ_TAG_GPS_MAPDATUM As Short = &H12            '// ʂɗpn}f[^ 	
    Public Const MIZ_TAG_GPS_DESTLATITUDEREF As Short = &H13     '// ړIn̖k(N)or (S)
    Public Const MIZ_TAG_GPS_DESTLATITUDE As Short = &H14        '// ړIn̈ܓxilj 	
    Public Const MIZ_TAG_GPS_DESTLONGITUDEREF As Short = &H15    '// ړIn̓o(E)or o(W)
    Public Const MIZ_TAG_GPS_DESTLONGITUDE As Short = &H16       '// ړIňoxilj 	
    Public Const MIZ_TAG_GPS_DESTBEARINGREF As Short = &H17      '// ړIn̕p̒P 		
    Public Const MIZ_TAG_GPS_DESTBEARING As Short = &H18         '// ړI̕pilj 		
    Public Const MIZ_TAG_GPS_DESTDISTANCEREF As Short = &H19     '// ړIn܂ł̋̒P 	
    Public Const MIZ_TAG_GPS_DESTDISTANCE As Short = &H1A        '// ړIn܂ł̋ilj
    Public Const MIZ_TAG_GPS_PROCESSINGMETHOD As Short = &H1B    '// ʕ̖
    Public Const MIZ_TAG_GPS_AREAINFORMATION As Short = &H1C     '// ʒn_̖
    Public Const MIZ_TAG_GPS_DATASTAMP As Short = &H1D           '// GPSt
    Public Const MIZ_TAG_GPS_DIFFERENATIAL As Short = &H1E       '// GPS␳ʒu

    Public Const MIZ_TAG_GPS_HPOSITIONINGERROR As Short = &H1F   '// ʌ덷	+EXIF 2.3


    Public Declare Unicode Function mizInitialize Lib "mgc4iz.dll" (ByRef intialData As MIZ_INI_DATA) As Integer

    Public Declare Unicode Function _
    mizBegin Lib "mgc4iz.dll" (ByVal functions As Integer, ByRef parameters As IntPtr) As Integer
    Public Declare Unicode Function _
    mizBegin Lib "mgc4iz.dll" (ByVal functions As Integer, ByRef parameters As MIZ_FIELD_DATA) As Integer
    Public Declare Unicode Function _
    mizBegin Lib "mgc4iz.dll" (ByVal functions As Integer, ByRef parameters As MIZ_FIELD_STRINGS) As Integer
    Public Declare Unicode Function _
    mizBegin Lib "mgc4iz.dll" (ByVal functions As Integer, ByRef parameters As MIZ_TEXT_SIZE) As Integer
    Public Declare Unicode Function _
    mizBegin Lib "mgc4iz.dll" (ByVal functions As Integer, ByRef parameters As MIZ_THUMBNAIL_IMAGE) As Integer
    Public Declare Unicode Function _
    mizBegin Lib "mgc4iz.dll" (ByVal functions As Integer, ByVal parameters As String) As Integer
    Public Declare Unicode Function _
    mizBegin Lib "mgc4iz.dll" (ByVal functions As Integer, ByRef parameters As MIZ_METHOD_FOR_CSV) As Integer
    Public Declare Unicode Function _
    mizBegin Lib "mgc4iz.dll" (ByVal functions As Integer, ByRef parameters As MIZ_METHOD_FOR_FORM0) As Integer
    Public Declare Unicode Function _
    mizBegin Lib "mgc4iz.dll" (ByVal functions As Integer, ByRef parameters As MIZ_METHOD_FOR_FORM1) As Integer
    Public Declare Unicode Function _
    mizBegin Lib "mgc4iz.dll" (ByVal functions As Integer, ByRef parameters As MIZ_HTML_RESOURCE) As Integer


    Public Declare Unicode Function _
    mizGetFileVersion Lib "mgc4iz.dll" (ByVal file As String, _
                                            ByRef major As Integer, _
                                            ByRef minor As Integer, _
                                            ByRef revision As Integer, _
                                            ByRef bild As Integer) As Integer

End Module
